package cz.jzitnik.chronos.entities;


import com.fasterxml.jackson.annotation.JsonBackReference;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import cz.jzitnik.chronos.interactions.Interaction;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@Entity
@NoArgsConstructor
@Table(name = "characters")
public class Character {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    private String name;

    @OneToMany(mappedBy = "charowner", cascade = CascadeType.ALL)
    @JsonManagedReference(value = "character-inventory")
    private List<Item> inventory = new ArrayList<>();

    @Enumerated(EnumType.STRING)
    private Interaction interaction;

    private boolean interactedWith;

    @ManyToOne
    @JsonBackReference(value = "room-characters")
    private Room room;

    @ManyToMany(mappedBy = "seenCharacters", cascade = CascadeType.ALL)
    @JsonIgnore
    private List<Player> playersWhoSaw = new ArrayList<>();

    @OneToOne(cascade = CascadeType.ALL)
    @JoinColumn(name = "interaction_data_id", referencedColumnName = "id")
    private cz.jzitnik.chronos.entities.Interaction interactionData;

    private String dialog;

    public Character(String name, Room room, String dialog) {
        this.name = name;
        this.room = room;
        this.dialog = dialog;
    }
}
