package cz.jzitnik.chronos.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Entity
@Getter
@Setter
@NoArgsConstructor
public class Interaction {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column(name = "start_text")
    private String startText;

    @Column(name = "interacted_with_text")
    private String interactedWithText;

    @OneToOne(mappedBy = "interactionData")
    @JsonIgnore
    private Character character;

    public Interaction(String startText, String interactedWithText, Character character) {
        this.startText = startText;
        this.interactedWithText = interactedWithText;
        this.character = character;
    }
}
