package cz.jzitnik.chronos.entities;

import com.fasterxml.jackson.annotation.JsonBackReference;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@Entity
@NoArgsConstructor
public class Item {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Enumerated(EnumType.STRING)
    private ItemType itemType;

    @ManyToOne
    @JsonBackReference(value = "player-inventory")
    private Player owner;

    @ManyToOne
    @JsonBackReference(value = "character-inventory")
    private Character charowner;

    @ManyToOne
    @JsonBackReference(value = "room-items")
    private Room room;

    public Item(ItemType itemType, Character charowner) {
        this.itemType = itemType;
        this.charowner = charowner;
    }

    public Item(ItemType itemType, Player owner) {
        this.itemType = itemType;
        this.owner = owner;
    }
}
