package cz.jzitnik.chronos.entities;

import jakarta.persistence.*;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
public class Message {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    private Player author;

    private String content;

    @Enumerated(EnumType.STRING)
    private MessageType messageType;

    public Message(Player author, String content) {
        this.author = author;
        this.content = content;
        this.messageType = MessageType.CUSTOM;
    }

    public Message(Player author, String content, MessageType messageType) {
        this.author = author;
        this.content = content;
        this.messageType = messageType;
    }
}