package cz.jzitnik.chronos.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

@Entity
@Getter
@Setter
@NoArgsConstructor
public class Room {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    private String name;

    @OneToMany(mappedBy = "room", cascade = CascadeType.ALL)
    @JsonManagedReference(value = "room-items")
    private List<Item> items = new ArrayList<>();

    @OneToMany(mappedBy = "room", cascade = CascadeType.ALL)
    @JsonManagedReference(value = "room-characters")
    private List<Character> characters = new ArrayList<>();

    @ManyToOne
    @JsonIgnore
    private Game game;

    @OneToMany(mappedBy = "currentRoom", cascade = CascadeType.ALL)
    @JsonIgnore
    private List<Player> players = new ArrayList<>();

    @OneToOne(mappedBy = "defaultRoom")
    @JsonIgnore
    private Game gameDefault;

    public Room(String name, Game game) {
        this.name = name;
        this.game = game;
    }
}
