package cz.jzitnik.chronos.repository;

import cz.jzitnik.chronos.entities.Message;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface MessageRepository extends JpaRepository<Message, Long> {

    @Query("""
            SELECT m FROM Message m
            WHERE m.author.game.id = :gameId
            ORDER BY m.id DESC
            """)
    List<Message> findLastMessagesByGameId(@Param("gameId") Long gameId, Pageable pageable);
}
