package cz.jzitnik.chronos.services;

import cz.jzitnik.chronos.entities.*;
import cz.jzitnik.chronos.entities.Character;
import cz.jzitnik.chronos.interactions.Interaction;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

@Service
public class InitGameService {
    public Room initGame(Game game) {
        var rooms = new ArrayList<Room>();

        // Outside
        var outside = new Room(
                "Outside", // Name
                game
        );
        var outside_characters = new ArrayList<Character>();
        var elf_items = new ArrayList<Item>();
        var elf = new Character(
                "Skřítek",
                outside,
                "Ahoj já jsem skřítek... Můj dialog doplnit"
        );
        elf_items.add(new Item(ItemType.LUCK_POTION, elf));
        elf.setInventory(elf_items);
        outside_characters.add(elf);
        outside.setCharacters(outside_characters);

        // Stodola
        var stodola = new Room(
                "Stodola",
                game
        );
        var stodola_characters = new ArrayList<Character>();
        var farmar = new Character(
                "Farmář",
                stodola,
                "Ahoj já jsem farmář a budeš se mnou hrát kámen nůžky papír. Dialog doplnit."
        );
        farmar.setInteraction(Interaction.Farmer);
        farmar.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "Tak si zahrajeme kámen nůžky papír",
                "Se mnou jsi již hrál kámen nůžky papír. Znovu už ti fragment klíče nedám",
                farmar
        ));
        stodola_characters.add(farmar);
        stodola.setCharacters(stodola_characters);

        rooms.add(outside);
        rooms.add(stodola);

        game.setRooms(rooms);

        // Return a room that all players will spawn in
        return outside;
    }
}