package cz.jzitnik;

import cz.jzitnik.game.Chronos;
import cz.jzitnik.utils.Cli;

import java.io.IOException;
import java.util.List;

public class Main {
    public static void main(String[] args) throws IOException {
        Chronos chronos = new Chronos();

        Cli.printHeader("Načítání hry Chronos");
        Cli.info("Načítání konfigurace...");

        if (chronos.hasConfig()) {
            chronos.loadData();
            Cli.success("Konfigurace byla úspěšně nalezena a načtena!");
        } else {
            // Setup a server
            Cli.info("Konfigurace nebyla nalezena! Vytvářím novou.");
            chronos.setup();
        }

        if (!chronos.hasUser()) {
            System.out.println();
            Cli.type("Nyní si buď vytvoříte vlastní hru a nebo se připojíte do již existující hry");
            System.out.println();

            String[] options = {"Vytvořit novou hru", "Připojit se do již existující hry"};
            var option = Cli.selectOptionIndex(List.of(options));

            switch (option) {
                case 0:
                    chronos.createNewGame();
                    chronos.addUser();
                    Cli.success("Byl jste úspěšně zaregistrován jako první hráč!");
                    chronos.adminPanel();
                    break;
                case 1:
                    chronos.connectToExisting();
                    chronos.addUser();
                    Cli.success("Byl jste úspěšně zaregistrován jako hráč!");
                    break;
                default:
                    System.out.println("Error"); // This will never happen
            }
        }

        Cli.info("Prosím počkejte...");
        chronos.waitForStart();
        Cli.info("Hra začala!");
        System.out.println("\n\n");
        Cli.printHeader("Chronos");
        chronos.visit();
    }
}