package cz.jzitnik.game;

import cz.jzitnik.api.ApiService;
import cz.jzitnik.api.requests.MessageRequest;
import cz.jzitnik.api.types.Message;
import cz.jzitnik.utils.Cli;
import lombok.AllArgsConstructor;

import java.io.IOException;
import java.util.Collections;

@AllArgsConstructor
public class Chat {
    private ApiService apiService;
    private String playerKey;

    public void display() throws IOException {
        System.out.println();
        var response = apiService.getMessages(playerKey).execute();
        var messages = response.body().getData().get();
        Collections.reverse(messages);

        for (Message message : messages) {
            System.out.println(message.getString(apiService, playerKey));
        }
    }

    public void sendMessage() throws IOException {
        System.out.println();

        var console = System.console();

        var messageContent = console.readLine("Zadejte zprávu: ").trim();

        if (messageContent.isEmpty()) {
            Cli.error("Zpráva nesmí být prázná!");
            return;
        }

        if (messageContent.length() > 100) {
            Cli.error("Zpráva nesmí být delší jak 100 znaků!");
            return;
        }

        var messageRequest = new MessageRequest(messageContent);

        apiService.sendMessage(playerKey, messageRequest).execute();

        Cli.success("Zpráva byla odeslána!");
    }
}
