package cz.jzitnik.game;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import cz.jzitnik.utils.ConfigPathProvider;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.File;
import java.io.IOException;
import java.nio.file.Path;

@Getter
@Setter
@NoArgsConstructor
public class LocalData {
    private String server;
    private String userSecret;
    private String gameKey;

    public void saveData() {
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            String configPath = ConfigPathProvider.getPath();
            File file = new File(Path.of(configPath, "config.json").toString());

            File parentDir = file.getParentFile();
            if (!parentDir.exists()) {
                parentDir.mkdirs();
            }

            objectMapper.writeValue(file, this);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}