package cz.jzitnik.game.interactions;

import cz.jzitnik.api.ApiService;
import cz.jzitnik.api.requests.InteractionRequest;
import cz.jzitnik.api.types.Character;
import cz.jzitnik.utils.Cli;

import java.io.IOException;
import java.util.Arrays;

public class Interactions {
    public static void runInteraction(Character character, ApiService apiService, String playerKey) throws IOException {
        var response = apiService.getInteractionData(playerKey, character.getId()).execute();
        var interactionData = response.body().getData().get();

        if (character.isInteractedWith()) {
            Cli.type(character, interactionData.getInteractedWithText());
            return;
        }

        Cli.type(character, interactionData.getStartText());

        switch (character.getInteraction()) {
            case Farmer ->  {
                var options = new String[] {"Kámen", "Nůžky", "Papír"};
                var selected = Cli.selectOptionIndex(Arrays.stream(options).toList());

                var requestData = new InteractionRequest(String.valueOf(selected), character.getId());

                var res = apiService.interact(playerKey, requestData).execute();
                var interactionResponse = res.body().getData().get();

                Cli.type(character, interactionResponse.getResponseText());

                if (interactionResponse.isSuccess()) {
                    Cli.gotItems(interactionResponse.getItems());
                }
            }
        }
    }
}
